Solidworks Import Converter - Main Table of Contents

Solidworksâ Assembly & Parts Import Converter

Quick Jump:

Visual Snapshot Index of Each Import Converter Panel

This help file describes the Solidworks import converter module which allows geometry, hierarchy and materials (assembly data) to be imported from native disk-based Solidworks files or from a running copy of the Solidworks 3D solid modeling application using the Solidworks automation API. No intermediate files are used in the translation.

This import converter allows data to be directly imported from Solidworks into any Okino compliant program, such as NuGraf, PolyTrans, the 3ds Max native plug-ins, or the Maya native plug-in module.

CP3 Scooter Concept Image. Solidworks to Cinema-4D via Okino's PolyTrans

CAD System. Artist: Christoph Bodensieck, © Industrial PDD & Switch Mobility.

Misumi IP44 Spotlight. Solidworks to Maya via PolyTrans-for-Maya.

Rendered with ArtVPS. Product Design Engineer: Stuart Wells © Astro Lighting Ltd

** Important - Update Your Copy of Solidworks **

You should download and install the most recent service pack for Solidworks from the Solidworks WEB site.

See Also:

Features of the Solidworks Import Conversion System

Visual Snapshot Index of Each Import Converter Panel

Important Runtime Information, How-To’s, and Execution Notes

Solidworks "COM Automation Server" - An Overview

Alternative Methods to Importing Solidworks Data

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworksâ is a registered trademark of Solidworks Corporation. 3ds Maxâ and Mayaâ are registered trademarks of Autodesk Inc. All other brand names, product names or trademarks belong to their respective holders.


Features of the Solidworks Import Conversion System

· One of the most well developed, supported and used CAD importers written by Okino, since 1998. It has been at the core of our CAD importers, being used by a large percentage of our Okino software users.

· Import from a live running copy of Solidworks, or from native Solidworks files on disk (no copy of Solidworks required for this latter feature).

· Supports the import of 3D CAD assemblies (.sldasm files), part files (.sldprt) and drawing/presentation files (.slddrw) via automation mode or display list mode.

· Imports and retains: assembly hierarchy information and assembly names, as well as BREP structure of the source model (bodies and faces). Can query accurate vertex normals, uv texture coordinates and UV tangent vectors from Solidworks directly.

· Solidworks "configurations" can be chosen via a wizard panel when importing via the "Automation" mode of import.

· The quality of the model (the number of polygons) can be controlled when importing from Solidworks (but not when importing from files directly on disk).

· If one part is instantiated N times in the Solidworks assembly tree then this importer will recognize such a situation and use Okino's core database master/instance capability to import the part just once and instantiate it N times. This feature can be disabled so that assembly-level part modifications within Solidworks (and using the automation import mode) can be imported, such as per-instance colors and feature changes (such as per-part hole cuts).

· Okino's "CAD Scene and Hierarchy Optimization System" has been integrated right into the Solidworks importer. This is most important when importing large CAD models into 3ds Max, Maya or Lightwave. These animation packages tend to have performance problems then the source CAD model is large, and/or has a large number of individual parts (which is often the case with the BREP model topology of data provided by Solidworks).

· The native PolyTrans plug-in systems for 3ds Max (PolyTrans-for-3dsMax) and Maya (PolyTrans-for-Maya) have been refined since 1998 specifically for importing large CAD assembly models from Solidworks. This has come about partly from our good software users, and also from the main Okino CAD programmers who have been specializing in CAD to non-CAD conversion software since 1988.

· A good number of important options that can be (optionally) set prior to import, to control most situations that could be encountered with Solidworks data import. Many options have come about from end-user requirements or situations.

· Complete control over material parameter modification on an automatic basis. Many CAD systems like Solidworks have basic material parameters (like color, ambient + diffuse shading coefficients, opacity, etc) but when they are transferred over to a rendering and animation system they often look "too bright" or "highly ambient". This can be expected and is quite normal. The material tweak parameters easily allow such saturated shading values to be automatically compensated.

· If you are importing the Solidworks data into Okino's PolyTrans or NuGraf software then it is possible to "refresh" or "update" the scene data directly from Solidworks without having to re-import the whole scene again.

See Also:

Visual Snapshot Index of Each Import Converter Panel

Important Runtime Information, How-To’s, and Execution Notes

Solidworks "COM Automation Server" - An Overview

Alternative Methods to Importing Solidworks Data

The File Import Process Using Okino’s PolyTrans or NuGraf


Visual Snapshot Index of Each Import Converter Panel

Click below for help on any Solidworks import converter panel:

Intro Panel | Data Source Selection | Beginner/Expert Mode
Display-List/Automation | Document Configuration | New/Update Scene
Beginner Precision | Expert Precision | Expert Precision # 2

Material Import | Material Tweaks | Errors, Statistics & Scaling


Runtime Suggestions

This short section explains the most fundamental and important suggestions that we pass on to users of the Solidworks CAD importer. Taking into account these suggestions will make your usage of the software highly efficient. This section is accessible by pressing the "Suggestions…" hyperlink found on some of the importer wizard panels.

Topology Units: "Bodies" vs "Faces" Suggestions

· For the most memory efficient and fastest imports, always use Bodies. Each CAD "part" will be imported as one body object, and possibly one additional "quilt" object. This mode will also allow for crack-free mesh creation, whereas the "Faces" mode will not.

· Sometimes materials will be assigned to the "face level" in the CAD model and not the "body" level. In such cases, enable the "Faces" radio button and always make sure the Enable Hierarchy Optimization option is enabled on the last importer panel. "Faces" import mode can be memory inefficient and slow because each CAD "part" will be imported as many individual objects, each object corresponding to one NURBS surface from the original CAD part. Also, crack-free mesh creation cannot be provided since each NURBS surface is imported independently of each other.

"Hierarchy Optimization" Suggestions

· This is absolutely the most important option to keep enabled in most cases. It can make all the difference between importing a CAD model quickly, with little memory usage and the fewest objects verse importing it slowly, with all memory being used up, and with an excessive number of objects. This is particularly true if the Topology radio buttons are set to "Faces". This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders. It can have profound results, in particular, for CAD models imported into 3ds Max, Maya and Lightwave. This option is not enabled during NURBS surface import since it would otherwise convert all the NURBS to polygons during the collapse process.

Scaling of the Model Suggestions

· Model scaling is an important, yet often overlooked aspect of the CAD import process by our users.

· In a nutshell, you should make sure your imported model generally ranges from 1x1x1 to 1000x1000x1000 units in size. Often we see customers importing a model which is only 0.001 units across - most downstream programs do not have the accuracy to display, render or manipulate such small models. Ditto on the model being too large (e.g. 1 million units wide).

· After your first file import use the destination program to determine the overall width, height and depth of the model, in general scaling terms. This can often be done by moving the cursor across the model and watching the current "XYZ Location" status bar message. If the model is too large, re-import it and change the Additional Scaling To Apply type-in box to a number such as 0.1, 0.01 or 0.001 (10x, 100x and 1000x times smaller). If the model is too small, re-import it and change the Additional Scaling To Apply type-in box to a number such as 10, 100 or 1000 (10x, 100x and 1000x times larger).

General Suggestions

· Always choose the Expert Mode so that you can control all the options discussed above.

See also:

Main Index Page of This Online Help System


Important Runtime Information, How-To’s, and Execution Notes

· How can I change the mesh density (quality of the imported model, number of polygons) when using the "Display List" import method?

The mesh density will be preset from the vendor who last saved out the Solidworks .sldasm file to disk. While the preset mesh density is usually very nice, the vendor can change it inside of the Solidworks program as follows: "Tools / Options", then the "Document Properties" tab, and finally modifying the "Shaded resolution" slider on the "Image Quality" panel. Once the assembly has been re-saved to disk, the vendor should send you the top-level .sldasm file (preferably inside a ZIP file). This file will be imported into Okino software using the native Solidworks importer, "Display List" mode.

· What file format should I use if I can’t acquire native Solidworks files?

Refer to the section "Alternative Methods to Importing Solidworks Data". In general, you will want to use "IGES solids" exported from Solidworks. This requires the Okino Granite/Pack license for the IGES solids importer.

· How do I fix imported models with "Cracks" between adjacent polygon faces?

If you are finding that holes or cracks appear between adjacent faces of the imported Solidworks data, then use "Expert Mode" during an import process and set the "Topology Units" option to "Bodies" on the Expert Precision Options # 2 wizard panel. By selecting "Bodies" Solidworks is able to use equal surface subdivision on both sides of adjacent faces, thus eliminating the cracks.

· My model appears very small when imported into the destination program. Why?

If you created your Solidworks data in "millimeters" then the model will appear about 1000 times too small when imported into the destination program. The solution is to rescale the imported data to the size you desire using the drop-down scaling combo box shown on the Errors, Statistics & Scaling panel. You can also use this panel to match the source CAD units from Solidworks to the destination units of your modeling program; for example, 3ds Max uses "inches" by default, Lightwave uses "centimeters" and Maya uses "meters".

· What do I do if "ole_error" or "COleDispatchException" errors are displayed during imports?

This error simply never occurs, but we’ll include this following text for reference. To fix these problems, exit Solidworks and exit the destination program (NuGraf, PolyTrans, Maya or 3ds Max) then try again. You might also want to ensure that Solidworks is not running as a process in the Windows "Task Manager", "Processes" tab. The errors are happening inside the COM portion of Microsoft Windows because of various blockages in the COM import process. They should never occur if you are running a recent updated release of Solidworks.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview


Solidworks 'COM Automation Server'- An Overview

Solidworks "COM Automation Server", An Overview

When importing part or assembly data from a live running copy of Solidworks, the data is transferred from Solidworks to the Okino side of the pipeline using the Solidworks "COM Automation Server Interface". This is an exposed set of functions which Solidworks "publishes" to the outside world. Okino's Solidworks importer queries all the part, assembly and material data from the running copy of Solidworks using this COM interface.

Such a pipeline is exemplified in this diagram:

In this diagram, an Okino compliant software package (such as NuGraf, PolyTrans, 3ds Max or Maya), on the left side, has asked Microsoft Windows to open up the application which "understands" Solidworks data files. Windows then executes Solidworks, the application on the right side above, and loads in the specified Solidworks data file. Using Microsoft "COM" technology, the Okino application on the left side (the "client") obtains direct access to the internal routines and data of Solidworks on the right side (the data "server"), as if the two programs were running as one. Object mesh data, hierarchy and materials are then directly transferred to the Okino application for subsequent rendering or further data translation. Once the conversion has taken place the connection is closed and Solidworks is allowed to exit.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes


Alternative Methods to Importing Solidworks Data

If you do not, or cannot (for whatever reason) import assemblies via this specialized Solidworks import converter, then there are some alternatives by exporting explicit 3D files from Solidworks directly and then importing them into Okino software. There should be no case where you cannot import Solidworks files via Okino's importer, as the "Display List" method can always be used to import files without a local copy of Solidworks installed on your computer. Note: when using "Display List" import method always keep the "Optimize Hierarchy" checkbox option enabled.

1) Conversion via IGES solids, exported from Solidworks

If you do not own a copy of Solidworks, and you wish to personally control the mesh density (the quality of the final model, as defined by the number of polygons), then the one and only logical way to do this is via IGES solids, written out from Solidworks itself. Each exporter of Solidworks is broken in some regard but only IGES solids can properly bring over the part naming, part hierarchy, materials and BREP solids topology information.

Within Solidworks, have your vendor of the IGES file set up the Solidworks IGES export options as follows:

- Press "Reset" to ensure the start-up IGES options are chosen

- Change the top combo box to "Manifold Solid (type 186)"

- Disable the "Flatten assembly hierarchy" checkbox

You would then import the IGES solids file into Okino software using the IGES importer provided in the Granite/Pack license. If you do not see any color on the model, then re-import with the "Topology = Faces" radio button chosen. Also, make sure that your imported file is roughly (1 x 1 x1) to (10k x 10k x 10k) units in size – if too small or too large then change the scale value on the last panel on the IGES importer wizard – you basically do not want to import the model too small, such as 0.01 units wide.

2) Conversion via a single .sldasm file, "Display List" method

If you do not own a copy of Solidworks, and you wish to import from native Solidworks files (.sldasm and .sldprt), while controlling the mesh density (the overall number of polygons to define the mesh quality) then you can do this:

· Ensure that you have the Okino CAD/Pack license.

· Ask your CAD vendor to send you the "top level .sldasm file".

The mesh density will be preset from the vendor who last saved out the Solidworks .sldasm file to disk. While the preset mesh density is usually very nice, the vendor can change it inside of the Solidworks program as follows: "Tools / Options", then the "Document Properties" tab, and finally modifying the "Shaded resolution" slider on the "Image Quality" panel. Once the assembly has been re-saved to disk, the vendor should send you the top-level .sldasm file (preferably inside a ZIP file). This file will be imported into Okino software using the native Solidworks importer, "Display List" mode.

3) You can also use VRML2 files exported from Solidworks, but they do not convey any hierarchy (inter-part assembly) information.

4) The Solidworks export file formats supported by Okino software, in alphabetical order, are:

· ACIS SAT - Use v7 for PTC ACIS import, else newest version for Spatial ACIS import

· CATIA CGR

· HOOPS HSF

· IGES 144 trimmed NURBS (surfaces) - For Okino IGES import

· IGES BREP solids-based NURBS - For PTC IGES import

· Parasolid .x_t ASCII

· ProE assembly (very slow to export from Solidworks. Not recommended)

· STEP AP203 and AP214

· STL (triangular polygons) - least favoured file format (very trivial)

· U3D

· VRML 2.0

ACIS v7, IGES solids, Parasolid, ProE and STEP files must be imported via Okino's "Granite" series of BREP solids importers. ACIS SAT (up to the newest version) is to be imported by Okino's special "Spatial ACIS SAT" importer (always guaranteed to work on the newest ACIS .sat files). CATIA CGR is imported by Okino’s CATIA v5 importer.

Note: conversions out of Solidworks should never take more than a few minutes, or tens of minutes at most. If you find that the export from Solidworks is taking longer, then something is wrong with the built-in exporter of Solidworks. No file export process should ever take hours or days.

Note 2: Not all of these file formats can output Solidworks assemblies as well as the Okino Solidworks import plug-in can import them directly. In particular, objects might be output as a single entity, hierarchy might be lost, materials might be dropped, or data integrity might be jeopardized.

The following table itemizes our findings from tests we have performed when exporting Solidworks data to Okino software:

File Format | Entity Type | Supports Hierarchy? | Supports Materials? | Supports Texture Maps?
ACIS SAT | Solids | No | No | No
CATIA CGR | Polygons | No | Yes | No
HOOPS HSF | Polygons | None exported by SW | Yes | No
IGES | NURBS/Solids | Yes | Yes | No
Parasolid | Solids | Yes | Yes | No
ProE/Creo (slow to export) | Solids | Yes | No | No
STEP AP203 | Solids | Yes | Yes | No
STEP AP214 | Solids | Yes | Yes | No
STL – Do not use! | Polygons | Not Applicable in STL | No | No
U3D | Polygons (can be terribly slow!) | Yes | Yes | Yes
VRML2 | Polygons | None exported by SW | Yes | No

STL is never recommended. It is one of the world’s most horrible of 3D file formats.

Solidworks "eDrawings" are none other than HOOPS HSF files. However, they are purposely encrypted by Solidworks Corp and hence Okino cannot extract the HSF data from these files.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


The File Import Process Using Okino's PolyTrans Or NuGraf

Once PolyTrans/NuGraf, the Solidworks plug-in and Solidworks have been installed on your machine, a typical import process proceeds as follows (the process is similar when importing directly into 3ds Max or Maya directly):

· From the NuGraf File/Import menu, or the PolyTrans Translate!/Import menu, select "Solidworks File...".

· Solidworks executes.

· The Solidworks import wizard appears inside the NuGraf or PolyTrans software, showing the Intro Panel. The "Next" button is pressed.

· The Data Source Selection panel appears next. This allows you to choose between reading in the data from a Solidworks file located on your hard disk, or importing data from the currently open Solidworks document.

· If you select the "Open document file" radio button and press "Browse" then the Microsoft Windows file selector dialog box will appear. One or more Solidworks part (.sldprt) or assembly (.sldasm) files should be chosen. Assembly files are preferred since they contain more info. The files are loaded into the running copy of Solidworks once you press the "Next" button.

· Once the source data file has been specified, you will be presented with options on how the data is to be opened. This can be done by "Display List" or "Automation". Display list will allow .sldprt, .slddrw and .sldasm files to be opened without a local copy of Solidworks on your machine; however, control over the number of polygons and querying of certain data items will not be possible. The automation method opens the file in a running copy of Solidworks and transfers the data using a "COM Server" interface for greater data connectivity.

· In expert mode, you will then be presented with optionsto import the data as a completely new scene, or re-fresh the data in the currently imported scene. This will only work when importing into Okino's stand-alone NuGraf or PolyTrans software packages. If the "Import a separate copy" radio button is selected then you will have the option of enabling the "Optimize hierarchy" checkbox; this will compress up the number of parts in the imported scene so that the scene displays, renders and animates more efficiently.

· The Beginner/Expert Mode panel appears next. This allows you to choose between further panels which are suitable for beginners, or for experts who want ultimate control over the import conversion process.

· If the beginner mode is selected, then the next panel will show the Beginner Precision options. This panel determines what type of geometry attributes are imported (vertices, normals, tangents or auto-computed normals) as well as how many polygons will be used to approximate the parametric solid surfaces of the objects inside Solidworks (the surface tolerance deviation). Clicking the "Next" button will advance to the last panel of this introduction (the Errors & Stats panel).

· If the expert mode is selected, then the next panel will show the first of two Expert Precision options. This panel determines if polygons, polygons plus computed normals, or polygons + normals + uv texture coordinates + tangent vectors will be imported from Solidworks. Each increasing level will take longer to import the data.

· The next expert level panel will show the second of two Expert Precision # 2 options. This panel will allow you to further refine which polygon attributes are imported, as well as determine which the objects should be "imported by body" (as one chunk) or "imported by face" (multiple chunks per object); each has its benefits and disadvantages.

· The second last expert level panel will show the Material Import options panel. In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Solidworks so that they will render properly in the destination rendering program. Solidworks displays models in OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter.

· The last panel is the Errors, Statistics & Scaling. This presents some options to control how import converter errors are handled, and whether statistics should be displayed after the import process is completed. It also provides two drop-down combo boxes which allow the imported data to be scaled up in size or scaled down in size, as well as automatically scaled to match the source and destination scaling units.

Once the import wizard goes away, the solid model data in Solidworks is tesselated into triangular polygons and transferred into Okino's software. The process completes once the entire model has been imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Intro Panel Options

This is the first panel which appears once the Solidworks import converter has been loaded.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Data Source Selection Options

This second panel determines whether the import converter will obtain the data from the currently open Solidworks document, or if a Solidworks assembly/part file should be opened first in Solidworks. If you wish to select a Solidworks part (.sldprt), presentation/drawing (.slddrw) or assembly file (.sldasm) on disk, then press the "Browse" button and select one or more part or assembly files.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner/Expert Mode Options

This third panel determines whether subsequent panels will show simpler beginner options, or a variety of more complex options for expert users. Click on the telephone image for beginner mode, or the video camera for expert mode. We recommend the expert mode.

If you want to reset all of the import converter options to the default start-up values, then check-mark the "Reset import parameters before continuing" check box before pressing the "Next" button.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Display List vs. Automation Import Options

The Solidworks importer can import data using two different mechanisms:

"Display List Mode"

When the radio button is set to "Open Display List Data" the importer will read in the raw polygon data and assembly hierarchy info contained in each .sldasm assembly file or .sldprt part file located on disk. There is no need to have a copy of Solidworks on your machine if you use this mode. This is the simplest and most direct route to opening and importing Solidworks files. However, the main drawback is that the quality of the model (the number of polygons used to represent the solid data) cannot be modified, as the mesh model is predefined inside the .sldprt files.

"Automation Mode"

When the radio button is set to "Connect Directly to Solidworks via Automation" the importer will start up a hidden copy of Solidworks in the background and have the selected files(s) loaded into it. Then the Solidworks importer will use the COM interface to query and import the assembly and part information from the running copy of Solidworks into the local PolyTrans software. While a bit slower than the "Display List Mode" (when starting up Solidworks), this mode has the benefit of allowing you to control the quality of the imported model (the number of polygons used to represent the solid data), as well as querying additional data such as uv coordinates & UV tangent vectors, hidden state, suppressed part state, etc.

If the "Select specific configuration" checkbox is enabled then the next wizard panel in succession will allow you to visually choose which Solidworks assembly configuration to import.

Why is the "Select specific configuration" checkbox disabled??

This checkbox is disabled under 2 conditions:

1. You have chosen "Display List Mode" which cannot accommodate the selection of different configurations. Only "Automation mode" can provide configurations.

2. You have chosen the "Automation mode", but you have also chosen the Solidworks file to import from the list of "Last Recently Used" filenames in the Okino stand-alone software menu. Such menu items contain the original filename AND the configuration name (the configuration name is stored after the "|" fence character that you will see in the full menu name). Thus, to allow the same file to be imported again, but using a different configuration, do not choose the filename from the "Last Recently Used" list; instead, do a complete re-import of the file such as using the "File / Import / Solidworks" method of Okino NuGraf or "Translate! / Import / Solidworks" of Okino PolyTrans – by doing so this checkbox will no longer be disabled and you will be able to choose a new configuration to import.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Document Configurations Import Options

Document Configuration Import Options

If the "Select specific configuration" checkbox is enabled on the Display-List/Automation wizard panel then this panel will show up next in succession. It will allow for different configurations of the Solidworks assembly to be visually chosen. "Configurations" are different variations of the same assembly.

Note: for this wizard panel to function properly your computer must have the following file installed and registered (which occurs automatically when the main Solidworks modeling software is installed on your computer):

\program files\common files\solidworks shared\swdocumentmgr.dll

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Import New Scene or Update Existing Scene Options

This panel provides the option of importing a completely new scene from the source Solidworks data, or using the source Solidworks data to refresh an existing (previously imported) copy of the data. With the latter method, you could update one or more parts in Solidworks then use the "Update" radio button to refresh the destination scene with only the modified portions from the Solidworks scene.

The ability to update an existing scene will only work with the stand-alone PolyTrans and NuGraf software packages. It cannot be used to refresh a scene inside 3ds Max or Maya.

The normal import method is the top radio button, "Import a separate (new) Copy of the Document". If this option is enabled you will also be able to checkmark the "Optimize Hierarchy" option; this option will collapse hierarchies of hundreds of parts into many fewer parts, making the import of large and complex assemblies possible for programs such as 3ds Max, Maya, Lightwave and others (non-CAD programs which suffer in terms of performance for assemblies with large numbers of objects). The documentation for the "Optimize Hierarchy" option can be viewed by pressing the "Optimization options…" button and then the "Help" button on the optimizer's dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Beginner Precision Options

For beginners, this is one of the most important import converter panels. It determines "how much" data, how accurately the solid object data from Solidworks is converted to polygons, and how quickly the import process proceeds.

"Data Completeness" Slider

This slider determines which type of data is actually imported from Solidworks. Setting the slider all the way to the left will import the least attributes associated with the model, while setting the slider all the way to the right will import the most attributes possible. The increments on this slider are related to the options on the Expert Precision panel as follows:

Minimum - Import polygon data only. The imported data will appear faceted due to the lack of vertex normals. The data will also be "imported by body" which means that each solid entity in Solidworks (a body) will be imported as its own single object (rather than various sub-objects).

Some - Import polygons and vertex normals (smoothing info). This is useful is you want the imported objects to appear smooth, but you do not want to import uv texture coordinates for texture mapping or UV tangent vectors for bump mapping. Data is "imported by body" (see above).

Most - Import polygons, vertex normals and uv coordinates. This is useful is you want the imported objects to appear smooth, and to have default texture coordinates. The data will be "imported by face" which means that each solid will be imported as multiple sub-pieces, arranged in a hierarchical manner.

All - Import polygons, vertex normals, uv coordinates and tangent vectors. Same as above except that tangent vectors will be useful for adding bump mapping to objects via texture maps. Data is "imported by face" (see above).

"Surface Precision" Slider

Data inside Solidworks is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the left, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the right then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options

This is the first expert mode options panel which controls "how much" data, how accurately the solid object data from Solidworks is converted to polygons, and how quickly the import process proceeds.

"Data Imported" Radio Buttons

These radio buttons determine which type of data is actually imported from Solidworks:

Polygons Only - Only polygon data is imported. The imported data will appear faceted due to the lack of vertex normals.

Normals and Polygons - Polygon data will be imported as well as vertex normal (smoothing) information. This is useful if you wish the imported data to appear smooth. The determination if the vertex normals will be automatically computed, or queried from Solidworks, is selected on the next Expert Precision Panel # 2.

Query Normals, uv & Tangent - Polygon data will be imported as well as vertex normals, vertex uv texture coordinates and vertex UV tangent vectors. This is useful if you wish the imported data to appear smooth, to be able to easily assign 2D bitmap texture maps to the imported objects and to be able to easily assign 2D bump map textures to the imported objects.

"Surface Deviation" Slider

This option is only available for the "Automation" import method and not the "Display List" import method.

Data inside Solidworks is represented as "solids". When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the right, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the left then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported. The numeric value shown to the right of the slider is the maximum allowable deviation between the ideal solids surface and that of the approximated polygon surface; as this number gets smaller a larger number of polygons must be created in order to better approximate the ideal solids surface.

I Would Also Like to Fine Tune the Advanced Options

If this check box is enabled then the Expert Precision Panel # 2 will be shown when the "Next" button is pressed. This subsequent panel will allow further refinement of the import options.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Expert Precision Options # 2

Expert Precision # 2 Options

This expert mode options panel provides control over specialized aspects of the import process. It is only displayed if the "I Would Also Like to Fine Tune the Advanced Options" checkbox is enabled on the previous Expert Precision Panel # 2 dialog box.

The one option that might be most interesting to users is the "Topology Units" (see below).

Optimize vertices to speed up import processing"

If this check box is enabled then all duplicated (redundant) vertices of the imported data will be deleted before any normals, uv coordinates or UV tangent vectors are queried from Solidworks. This will greatly speed up the import process because redundant data quieries will not have to be made.

Normal Attribute Processing (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex normals are to be created for the imported polygon data. These options override the vertex normal import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex normals will be imported. The imported polygon data will not appear smooth when rendered.

Generate - A smoothing algorithm in the import converter will be enabled to automatically create vertex normals based on smoothing angle. This will create only an approximation of the real vertex normals from Solidworks. Since the real vertex normals are not imported from Solidworks, this option is faster than asking Solidworks for the accurate vertex normals. If this option is chosen then the "Smoothing Angle" text type-in box becomes enabled; higher values (near 90 degrees) will make your objects appear highly smoothed (no sharp corners) whereas lower values (around 15 to 20 degrees) will make your import objects appear more faceted, although smooth where they should be.

Import Only - The true vertex normals will be queried from Solidworks one by one. This is much slower but produces more accurate results.

Import & Optimize - The same as "Import Only", but the vertex normals will also be optimized so that any redundant coordinates are deleted.

uv Texture Coordinates (Pop-Down List Box)

This option is only available for the "Automation" import method and not the "Display List" import method.

This pop-down list box determines, absolutely, how vertex uv texture coordinates are to be imported from Solidworks. These options override the vertex uv texture coordinate import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex uv texture coordinates will be imported. You will not be able to apply 2D bitmap textures to the imported objects without these uv texture coordinates.

Import Only - The true vertex uv texture coordinates will be queried from Solidworks one by one.

Import & Optimize - The same as "Import Only", but the vertex uv texture coordinates will also be optimized so that any redundant coordinates are deleted.

UV Tangent Vectors (Pop-Down List Box)

This option is only available for the "Automation" import method and not the "Display List" import method.

This pop-down list box determines, absolutely, how vertex UV tangent vectors are to be imported from Solidworks. These options override the vertex UV tangent vector import methods selected on the previous Expert Precision Panel # 1:

-Skip- No vertex UV tangent vectors will be imported. You will not be able to apply 2D bitmap bump mapping textures to the imported objects without these tangent vectors.

Import Only - The true vertex UV tangent vectors will be queried from Solidworks one by one.

Import & Optimize - The same as "Import Only", but the vertex UV tangent vectors will also be optimized so that any redundant coordinates are deleted.

Topology Units: Bodies or Faces

This option is only available for the "Automation" import method and not the "Display List" import method.

Because Solidworks is a solid modeling package, internally it represents solids in "Brep" form (boundary representation). An object consists of a "body", which is made up of "shells" and each shell is made up of "faces". These faces are not to be confused with polygon faces of other programs.

If the "Bodies" option is chosen on this panel then each major object will be imported as one mesh object and you will not be able to easily assign materials to sub-components of the imported object.

If the "Faces" option is chosen on this panel then each major object will be imported as several sub-mesh objects, stored under one hierarchical parent folder (or "null object" as alternative lingo). Since the object is imported as several sub-objects, you may find it easier to assign materials. However, this method can ultimately result in a scene with a very large number of objects; in such cases you can reduce and optimize the number of objects by enabling the "Optimize Hierarchy" checkbox option on the New/Update Scene panel.

If the "Query normals" radio button is selected on the previous Expert Precision Panel # 1 then the "Topology Units" radio buttons will always be forced to the "By Face" import option. This is because the import converter can only query accurate normals from Solidworks when importing by individual faces. If the "Polygons Only" or "Normals and Polygons" radio buttons are selected on the Expert Precision Panel # 1 instead, then you have a selection of importing by body or importing by face.

** NOTE **

You may find that importing "By Body" to produce better tessellation results and less "cracks" or holes between adjacent edges. This is because each adjacent "face" of the body is taken into account when the two faces are tessellated (so that no holes appear between faces). If you import "By Face" then holes or "cracks" may appear between adjacent faces.

Flip Model so that 'Y' Axis is 'Up'

By default the data is imported so that the 'Y' up axis in Solidworks becomes the 'Y' up axis in Okino software. If this checkbox is enabled, then the imported data will be reoriented so that the 'Z' axis in Solidworks becomes the 'Y' Up axis in Okino software.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Import Options

In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from Solidworks so that they will render properly in the destination rendering program. Solidworks displays models using OpenGL and as such many models are overly saturated in ambient or diffuse color; this saturation of color does not look good in a photo-realistic rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter. The default action is to not modify any imported material characteristics; however, you will often find that imported Solidworks models appear "too ambient" or "too diffuse".

Import Method (Pop-Down List Box)

By default, three "material import processing" methods have been provided for you by clicking on the pop-down list box. You are also free to define your own methods by pressing the "New" button on the panel which will call up the Material Tweaks sub-dialog box:

Do Not Import Material Properties - No material properties will be imported at all.

Preserve Numerical Values - All materials will be imported from Solidworks without any change or tweaking.

Preserve Appearance (Recommended) - The material shading coefficients will be set to the following values, ensuring that the model should look ok when rendered:

· Diffuse shading coefficient = 0.4

· Ambient shading coefficient = 0.3

· Specular shading coefficient = 0.7

· Highlight value = 0.12 (0 = wide highlight, 1.0 = narrow highlight)

· Emission (luminous) shading coefficient = 0

· Opacity (inverse of transparency) = 1.0 (fully opaque)

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Material Tweak Options

This sub-dialog box provides ultimate control over how imported material properties should be modified so that the imported model can be rendered nicely in a photo-realistic rendering program. All too often the imported model appears "too ambient" or "too diffuse", resulting in rendered images that are washed out or with no gradual shading effects visible. By default you should use the "Preserve Appearance" pre-defined import method.

First, to add a new material processing method, press the "New" button on the Material Import panel. This will cause the sub-dialog box to appear in which you can set your custom material import processing options.

As an explanation of the various shading parameters listed on the sub-dialog box:

Diffuse: This controls the amount of color reflected from an object based on the direct light shining on it. A good default value is 0.4.

Ambient: This controls the amount of color reflected from an object based on the ambient light in a scene. A good default value is 0.1 through to 0.3.

Specular: This controls the intensity of the highlight on an object. A good default value is 0.7.

Highlight: This controls the width of the specular highlight on an object (0 = wide, 1.0 = very narrow). A good default value is 0.12.

Emission (luminous): This controls how much color is added to an object, irrespective of any light which shines on it (the higher the value, the more the object will appear to glow). In general you should keep this value at 0.

Opacity: This is the inverse of transparency. 0.0 will make the object fully transparent, while at 1.0 the object will be fully opaque.

For each material property, several actions can be performed on it during the import from Solidworks. Two sets of actions are provided, that which is performed when the diffuse color values is being imported and those which are performed when all other parameters other than diffuse are being imported.

The actions taken when importing the diffuse color value are described as follows:

- Skip - : The diffuse color value is not imported (no color change is made).

Use Default Coefficient: This action imports the diffuse color with no change made at all, but the diffuse shading coefficient for the color will be set to a "pleasant" value resulting in 3D scenes which render "photo-realistically" (in other words, without harsh or overly bright colors). This coefficient typically ranges from 0.3 through to 0.5. The "coefficient" mentioned here is the same as the "Shading Coefficients" on the "Color" surface attribute editor in Okino’s NuGraf Rendering System software.

Set Coefficient To: This behaves the same as "Use Default Coefficient" except that the diffuse shading coefficient for the diffuse color is set to a user specified value. Let’s assume you set this shading coefficient to 1.0 (the worse case); this would result in a rendered scene which was over saturated in diffuse color. To circumvent this problem (as is done in all 3D rendering packages), we "attenuate" the diffuse color by a specific percentage so that it won’t saturate the final rendered image when the shading is done.

Normalize Color and Coefficient: This is a hybrid approach which tries to automatically "guess" at proper diffuse shading coefficient values using the raw diffuse color imported from Solidworks. As mentioned, this shading coefficient is needed to create nice looking (nicely shaded) images in a photo-realistic rendering program. If this drop-down box option is chosen, then the diffuse shading coefficient will be derived directly from the relative intensity of the imported diffuse color. For example, if the imported diffuse color is (0.4, 0, 0), which is 40% of full-bright red, then the diffuse shading coefficient will be set to 0.4 and the diffuse color will be modified to be (1, 0, 0). When the new color (1,0,0) and the new shading coefficient (0.4) are multiplied together, it results in the original color imported from Solidworks (0.4, 0, 0). In general you may wish to use the "Use Default Coefficient" option to get good rendered results.

The actions taken when importing all parameters other than "diffuse" are described as follows (highlight value and opacity):

- Skip - : The material parameter is ignored during import.

Import Unchanged: The material parameter is imported as is, with no change.

Unconditionally Set To: The material parameter is not imported but rather it is set to the numeric value on the dialog box.

Import and Crop by: The material parameter is imported and remains unchanged if it is less than the numeric value on the dialog box. If it is greater, then the imported value will be clamped to be no greater than the numeric value on the dialog box.

Import and Scale by: The material parameter is imported and scaled by the numeric value on the dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


Errors and Statistics

Errors, Statistics, Scaling & Automatic Units Matching

One of the primary uses of this panel is to set up the "units matching". Data from Solidworks comes across the conversion pipeline in terms of "meters". However, the destination 3D program may not be using meters as its default measurement units. For example, 3ds Max uses "inches" by default, Lightwave uses "cm" and Maya uses "meters". The combo boxes on this panel allows the measurement units to be matched, as well as additional scaling to be applied to the imported geometry data.

This options panel also determines whether the import converter will "try its best" to overcome COM errors reported by Solidworks, and whether statistics will be printed after all the data has been imported. It also provides a drop-down combo box which allows the imported geometry to be scaled up in size or scaled down in size.

Data Scale

"Units conversion" is often an important aspect of importing CAD files. People who create 3D models in a modeling package will do so using a specific units system, such as meters or feet. However, when these models are imported into another 3D package that uses a different default units system (such as Lightwave which uses centimeters), a "units conversion" operation needs to occur (the imported model geometry needs to be rescaled).

This import panel determines what will be done when the units defined in the Solidworks file do not match current internal system units. If the units do not match, the Solidworks importer will rescale the imported geometry based on the ratio between the Solidworks units and the internal system units.

Unit of Measurement

You need to set this combo box to the measurement units system in effect for your destination 3D program. For example, set it to centimeters for Lightwave, inches for 3ds Max, centimeters for Maya, etc.

If you are importing into the Okino PolyTrans or NuGraf programs then you can either set the destination units measurement system via this combo box or set the combo box to "Current System" and then set the measurement system inside the main PolyTrans/NuGraf program (Edit/Preferences/Startup Preferences/Other/System Units).

Ignored No units; never do any geometry scaling.

Current System Scale data to match current internal Okino units

Use Document Set Okino units to Solidworks file units. No scaling done.

Microinches 1e-6 inches

Mils 1e-3 inches

Inches 2.54 centimeters

Feet 12 inches

Miles 1.6 kilometers

Microns 1e-6 meters

Millimeters 1e-3 meters

Centimeters 1e-2 meters

Meters 3.28 feet

Kilometers 0.62 mile

Custom Custom units are in effect.

If the "Custom" option is chosen then the numeric value contained in the "Additional scaling to apply" edit control defines the "units per meter" scale factor for a custom unit system. For example, if you were to enter "0.62" into the type-in box then this would be equivalent to the "Kilometers" units measurement system.

Additional Scaling to Apply (Combo Box)

This drop-down combo box allows imported geometry to be scaled up or down in size by units of 10, 100 or 1000 times. You are free to enter your own scaling factor into the type-in portion of the combo box if you wish (such as "5000"). If you created your model within Solidworks using "millimeters", for example, then the model will appear about 1000 times too small when imported into the destination program. The solution is to select a scaling option on this wizard panel appropriate for the size of the data as it appears in Solidworks. For example, if you model in millimeters within Solidworks then you will want to scale up by 1000 units so that the imported model will not look tiny.

NOTE: If the "Unit of Measurement" combo box is set to "Custom" then the "Additional scaling to apply" edit control defines the "units per meter" scale factor and not an absolute scaling factor.

Runtime Import Options

Import Assembly Level Part Modifications

This option is only available for the "Automation" import method and not the "Display List" import method.

Solidworks includes the capability to provide local modifications to a part at the assembly level. For example, you could have one part (such as a bolt) instanced 4 times at the assembly level. At the assembly level you could then override each instance with its own color, transformation and even features (such as cutting a hole in just 1 out of the 4 bolts).

If this checkbox is enabled then every instance of a part at the assembly level will create a unique meshed object upon import. In the case of our example, this will create 4 unique and separate bolts, each with their own color and each with all assembly-level feature changes applied to them (such as hole cuts).

If this checkbox is disabled), which is the default, then assembly-level modifications will be ignored. This is the default mode because it allows for faster and more compact file imports, since the Solidworks importer will create just one mesh object inside the Okino database and instantiate that raw mesh N times. In general this works fine for most files we have encountered. However, it will not allow for proper import of parts which lead to visual modifications to the parts at the assembly level (such as feature changes or color changes).

** If your Solidworks data imports with some parts looking wrong or lacking proper color assignment, then enable this checkbox. However, enabling the checkbox will not allow for the Okino object instancing mechanism to be used (which creates one unique mesh object and instantiates it N times).

Import Suppressed (Hidden) Objects

If this option is enabled then the converter will ignore (not import) objects in Solidworks which have been "suppressed". This option is only valid during "Automation" import mode and not "Display List" import mode.

Tolerate File Integrity Errors

If this option is enabled then the converter will not stop if it receives unexpected data as a result of a data query to Solidworks; in this case the import converter will just skip over that element and continue importing.

Report Statistics About the Imported File

If this check box is enabled then statistics will be reported after the data has been imported.

Merge Triangles To Quads, Max Angle = #

Solidworks, and all top-6 MCAD programs since the invention of NURBS in the 1980’s, always output triangular meshes and not quad meshes. This is because quads cannot accurately represent the curvature of NURBS surfaces.

This option is a post-processing step that merges triangles back to quadrilateral polygons (4 sided polygons). The number of vertices remain the same but the overall number of polygons are reduced.

If this option is enabled (check marked) then an algorithm will be invoked which merges multiple polygons into quads. If two adjacent triangles are nearly co-planar then they will be turned into a quadrilateral. The vertices of the adjacent edges must be welded together (shared) for this operation to proceed properly.

The test for co-planar polygons (polygons which are almost on the same plane as each other) is determined by the "Max angle" type-in box. This value is measured in degrees. Values near 0 will require that adjacent polygons be very much co-planar with each other, while higher values will allow polygons that meet at an angle to be considered. For example, if you have a curved object made of triangles then try setting the angle to 4 to 7 degrees. Higher values will allow more polygons to be merged.

NOTE: you can also apply this merging algorithm via the "Polygon Processing" functionality found in the stand-alone Okino software. On that dialog box you would invoke the "Merge Co-Planar Polygons into larger polygons" function. That alternative version also provides some more controls over whether vertex normals, vertex colors and vertex uv’s are to be taken into account (they are all taken into account when invoked via the polygon reduction system).

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Solidworks "COM Automation Server" - An Overview

Important Runtime Information, How-To’s, and Execution Notes


AFX_HIDP_default

No Help Available

No help is available for this message box.

<< If you wish to author help specific to each message box prompt, then remove the AFX_HIDP_xxx values from the [ALIAS] section of your .HPJ file, and author a topic for each AFX_HIDP_xxx value. For example, AFX_HIDP_INVALID_FILENAME is the help topic for the Invalid Filename message box. >>


HID_HELP


HID_HT_NOWHERE

No Help Available

No help is available for this area of the window.


HID_WIZBACK


HID_WIZFINISH


HID_WIZNEXT


HIDC_ANGLE

This value controls the smoothing criterion used when normals are being generated (as opposed to being queried from the server). It is based on the angle between abutting polygons; common smoothed vertex normals will be computed if the angle between their geometric surface normals is less than the angle specified.

Defaults to 45 degrees. Increase this value if the imported object appear to have overly rough surface. Decrease this value if the surface appears to be overly smoothed.


HIDC_BANNER


HIDC_BEGINNER


HIDC_BODIES


HIDC_ERROR_TORERANT


HIDC_EXPERT


HIDC_FACES


HIDC_FLIP_Y_UP

If this option is enabled then the model will be rotated so that its Up axis is aligned with the positive Y-axis instead of the positive Z-axis.


HIDC_NORMALS


HIDC_OPEN_CURRENT


HIDC_OPEN_FILE


HIDC_OPTIMIZE_VERTICES


HIDC_REPORT_STATS

If this checkbox is enabled then the import converter will print out the number of objects, polygons, normals, texture coordinates, tangent vectors and surfaces that were parsed from the SAT file.


HIDC_RESET_DEFAULT


HIDC_TANGENTS

If this checkbox is enabled then the import converter will import proper tangent vectors for each triangle vertex. Tangent vectors are necessary if bump map texture image is to be applied to the object at some time in the future.


HIDC_UV

If this checkbox is enabled then the import converter will import proper texture (u,v) coordinates for each triangle vertex. Texture coordinates are necessary if a bitmap texture image is to be applied to the object at some time in the future


HIDP_INVALID_PATH

Invalid Path

HIDP_INVALID_PATH